2005-11-28  Tom Yu  <tlyu@mit.edu>

	* t_cts.c, vectors.c: Don't include krb5.h.

2005-11-17  Ken Raeburn  <raeburn@mit.edu>

	* t_hmac.c, t_pkcs5.c: Don't include krb5.h.

2005-03-15  Jeffrey Altman <jaltman@mit.edu>

        * keyed_cksum.c: (krb5_c_is_keyed_cksum): this is a boolean 
          function.  It should not return -1U on error.  Instead return
          0 (false) so that the caller doesn't think it succeeded.

          The only two callers are rd_safe and mk_safe.  Neither checks
          for special cases.

2005-01-13  Ken Raeburn  <raeburn@mit.edu>

	* prng.c (krb5int_prng_init): Incorporate do_yarrow_init body.
	Don't check inited variable.
	(inited): Variable deleted.
	(krb5_c_random_make_octets, krb5int_prng_cleanup): Don't check
	it.
	(do_yarrow_init): Deleted.

2005-01-12  Tom Yu  <tlyu@mit.edu>

	* prng.c (read_entropy_from_device): Use ssize_t, not size_t, so
	read() returning -1 doesn't cause trouble.

2004-11-17  Ken Raeburn  <raeburn@mit.edu>

	* prng.c (do_yarrow_init): Move mutex initialization here.
	(krb5int_prng_init): Don't do it here.

2004-11-15  Sam Hartman  <hartmans@mit.edu>

	* t_prng.expected t_prng.reseedtest-expected :  Update expected
	PRNG test output and confirm that reseeds and gates happen correctly.

2004-10-29  Ken Raeburn  <raeburn@mit.edu>

	* prng.c (yarrow_lock): Rename to krb5int_yarrow_lock via macro,
	and change to be non-static.
	(krb5int_prng_init): Call do_yarrow_init here.
	(krb5_c_random_add_entropy): Don't call it here.  Don't lock the
	mutex, either.
	(krb5_c_random_make_octets): Don't lock the mutex.

2004-06-16  Ken Raeburn  <raeburn@mit.edu>

	* Makefile.in (MAC_SUBDIRS): Don't set.

2004-06-15  Ken Raeburn  <raeburn@mit.edu>

	* Makefile.in (SHLIB_DIRS, SHLIB_EXPLIBS, SHLIB_EXPDEPLIBS): Set
	to depend on the new support library.
	(SHLIB_LIBS): Don't define.
	(SHLIB_RDIRS): Set.

	* configure.in: Use BUILD_LIBRARY_WITH_DEPS instead of the no-deps
	version.

2004-06-04  Ken Raeburn  <raeburn@mit.edu>

	* Makefile.in (LIBBASE): Renamed from LIB.

2004-06-02  Ken Raeburn  <raeburn@mit.edu>

	* prng.c (init_once): Variable deleted.
	(krb5_c_random_add_entropy): Do the initialization once, using
	the yarrow_lock mutex instead of k5_once to protect it.

2004-05-24  Ezra Peisach  <epeisach@mit.edu>

	* t_nfold.c (fold_kerberos): Change nbytes argument to unsigned.

	* t_encrypt.c (compare_results): Declare static.
	(main): Free allocated memory before exit.

2004-05-13  Ken Raeburn  <raeburn@mit.edu>

	* Makefile.in (t_encrypt, t_prng, t_hmac, t_pkcs5, vectors,
	t_cts): Link test programs against thread support library.

2004-05-12  Ken Raeburn  <raeburn@mit.edu>

	* libk5crypto.exports: Add the DES tables back in; libdes425 uses
	them directly.

2004-05-07  Ken Raeburn  <raeburn@mit.edu>

	* configure.in: Check for endian.h and machine/endian.h.

2004-04-30  Ken Raeburn  <raeburn@mit.edu>

	* crypto_libinit.c (initialized): Variable deleted.
	(cryptoint_initialize_library, cryptoint_cleanup_library): Use new
	macros for automatic shared library init/fini functions.
	(prng_cleanup): Declaration deleted.
	(krb5int_prng_init, krb5int_prng_cleanup): Declare.
	(cryptoint_initialize_library): Call krb5int_prng_init.
	(krb5int_crypto_init): New function, checks that
	cryptoint_initialize_library was called successfully.
	(cryptoint_cleanup_library): Call krb5int_prng_cleanup only if the
	initializer ran.
	* crypto_libinit.h: Deleted.
	* prng.c: Include k5-thread.h.
	(init_once, init_error, yarrow_lock): New variables.
	(krb5int_prng_init): New function; finish initializing the mutex
	lock.
	(do_yarrow_init): New function.
	(krb5_c_random_add_entropy): Call it once only.  Lock the mutex
	before processing the input.
	(krb5_c_random_make_octets): Lock the mutex before extracting
	random bytes.
	(krb5int_prng_cleanup): Destroy the mutex.

	* Makefile.in (LIBINITFUNC, LIBFINIFUNC): New variables.

	* libk5crypto.exports: Drop the library init/fini functions and
	the DES tables from the export list.

2004-04-22  Ken Raeburn  <raeburn@mit.edu>

	* libk5crypto.exports: New file.

2004-03-22  Ken Raeburn  <raeburn@mit.edu>

	* pbkdf2.c (hmac1): Make a local copy of the supplied keyblock
	structure, in case we want to modify it.

2004-03-17  Ken Raeburn  <raeburn@mit.edu>

	* prng.c (krb5int_prng_cleanup): Renamed from prng_cleanup.
	* crypto_libinit.c: Include k5-int.h.
	(cryptoint_cleanup_library): Updated call.

2004-03-04  Ken Raeburn  <raeburn@mit.edu>

	* configure.in: Don't check for --enable-athena and don't define
	ATHENA_DES3_KLUDGE.

2004-02-24  Sam Hartman  <hartmans@avalanche-breakdown.mit.edu>

	* etypes.c: Remove ENCTYPE_LOCAL_DES3_HMAC_SHA1

2004-02-18  Ken Raeburn  <raeburn@mit.edu>

	* block_size.c, checksum_length.c, cksumtype_to_string.c,
	coll_proof_cksum.c, decrypt.c, encrypt.c, encrypt_length.c,
	enctype_compare.c, enctype_to_string.c, hmac.c,
	keyed_checksum_types.c, keyed_cksum.c, make_checksum.c,
	make_random_key.c, nfold.c, old_api_glue.c, prng.c,
	string_to_cksumtype.c, string_to_enctype.c, string_to_key.c,
	valid_cksumtype.c, valid_enctype.c, verify_checksum.c: Use ANSI C
	style function definitions.

2004-02-13  Ken Raeburn  <raeburn@mit.edu>

	* t_encrypt.c (compare_results): New function.
	(main): Use it to check decryption results against the original
	plaintext.  When testing with cipher state, encrypt and then
	decrypt (and verify) two messages.
	* Makefile.in (t_encrypt$(EXEEXT)): Depend on CRYPTO_DEPLIB.

2004-02-09  Ken Raeburn  <raeburn@mit.edu>

	* t_cts.c (test_cts): Process encryption and decryption IVs
	separately, make sure they match, and display the value.

2003-12-13  Ken Raeburn  <raeburn@mit.edu>

	* etypes.c (krb5_enctypes_list): Fill in required_ctype field.
	* mandatory_sumtype.c: New file.
	* Makefile.in (SRCS, OBJS, STLIBOBJS): Build it.

2003-07-22  Ken Raeburn  <raeburn@mit.edu>

	* block_size.c (krb5_c_block_size): Read new numeric fields for
	key/block/hash sizes instead of calling functions.
	* checksum_length.c (krb5_c_checksum_length): Likewise.
	* combine_keys.c (krb5int_c_combine_keys, dr): Likewise.
	* hmac.c (krb5_hmac): Likewise.
	* make_checksum.c (krb5_c_make_checksum): Likewise.
	* make_random_key.c (krb5_c_make_random_key): Likewise.
	* pbkdf2.c (hmac1): Likewise.
	* string_to_key.c (krb5_c_string_to_key_with_params): Likewise.
	* t_hmac.c (hmac1): Likewise.

2003-07-13  Ken Raeburn  <raeburn@mit.edu>

	* pbkdf2.c (foo): Never call com_err.

2003-06-25  Ken Raeburn  <raeburn@mit.edu>

	* checksum_length.c (krb5_c_checksum_length): Handle trunc_size.

2003-06-23  Ken Raeburn  <raeburn@mit.edu>

	* cksumtypes.c (krb5_cksumtypes_list): Add aes128/256 hmacs, with
	new trunc_size field.

	* make_checksum.c (krb5_c_make_checksum): If trunc_size is
	specified, shrink the computed checksum down to the indicated
	size.

2003-06-05  Sam Hartman  <hartmans@mit.edu>

	* string_to_key.c (krb5_c_string_to_key_with_params): Only allow
	AFS s2k  for DES enctypes

2003-05-15  Sam Hartman  <hartmans@mit.edu>

	* combine_keys.c (enctype_ok): new function to determine if we support combine_keys for a particular enctype

2003-05-13  Ken Raeburn  <raeburn@mit.edu>

	* etypes.c (krb5_enctypes_list): Add names aes128-cts and
	aes256-cts as aliases.

2003-05-13  Sam Hartman  <hartmans@mit.edu>

	* t_encrypt.c: Add aes enctypes

2003-05-08  Sam Hartman  <hartmans@mit.edu>

	* string_to_key.c: Move krb5_c_string_to_key_with_params to krb5.h

2003-04-13  Ken Raeburn  <raeburn@mit.edu>

	* pbkdf2.c (krb5int_pbkdf2): Provide a temporary buffer for the
	output from F, if the remaining space in the output buffer isn't
	big enough.  Free the temporary buffers before returning.

	* etypes.c (krb5_enctypes_list): Use krb5int_aes_encrypt_length,
	and krb5int_aes_dk_encrypt, and krb5int_aes_dk_decrypt for AES.

2003-03-06  Alexandra Ellwood  <lxs@mit.edu>

    * prng.c: use Unix randomness sources on Mac OS X.

2003-03-05  Ken Raeburn  <raeburn@mit.edu>

	* Makefile.in (OBJFILELIST, OBJFILEDEP) [##DOS]: Add aes.lst.
	(all-windows, clean-windows, check-windows): Process aes
	directory.

2003-03-04  Ken Raeburn  <raeburn@mit.edu>

	* etypes.c: Include aes_s2k.h.
	(krb5_enctypes): Add AES enctypes.  Update s2k function names.
	* pbkdf2.c (krb5int_pbkdf2): Now static.  Output data descriptor
	is const.
	(krb5int_pbkdf2_hmac_sha1_128, krb5int_pbkdf2_hmac_sha1_256):
	Deleted.
	* string_to_key.c (krb5_c_string_to_key_with_params): Renamed from
	krb5_c_string_to_key, takes new params argument and passes it
	through.  Declare before use.
	(krb5_c_string_to_key): New function, passes null params.

	* t_pkcs5.c (test_pbkdf2_rfc3211): Update calls to
	krb5int_pbkdf2_hmac_sha1 for new API.
	* vectors.c (test_mit_des_s2k): Update krb5_des_string_to_key call
	for new API.
	* Makefile.in: Update dependencies.

2003-03-03  Ken Raeburn  <raeburn@mit.edu>

	* pbkdf2.c (F): Now takes krb5_data for password and salt.
	(krb5int_pbkdf2, krb5int_pbkdf2_hmac_sha1,
	krb5int_pbkdf2_hmac_sha1_128, krb5int_pbkdf2_hmac_sha1_256):
	Likewise, and for output also.
	* vectors.c (test_pbkdf2): Calls updated.
	(main): Run pbkdf2 tests.

2003-02-03  Ken Raeburn  <raeburn@mit.edu>

	* aes: New directory, containing AES implementation from Brian
	Gladstone, tweaked a little for the krb5 build system.
	* configure.in: Build its makefile.
	* Makefile.in (LOCAL_SUBDIRS, LOCALINCLUDES, STOBJLISTS,
	SUBDIROBJLISTS): Add aes entries.

	* t_cts.c: New test file.
	* Makefile.in (EXTRADEPSRCS): Add t_cts.
	(t_cts$(EXEEXT)): New rule.

	* Makefile.in (SRCS, OBJS, STLIBOBJS): Add pbkdf2.
	(EXTRADEPSRCS): Remove pbkdf2.c.
	(t_pkcs5$(EXEEXT)): Don't list pbkdf2.$(OBJEXT).

	* t_nfold.c (fold_kerberos): New function.
	(main): Call it with different lengths.
	* vectors.c: Include ctype.h and hash_provider.h.
	(test_nfold, test_mit_des_s2k, test_s2k, test_dr_dk): Test case
	data now static and const.
	(test_nfold): Add "Q" and "ba" tests from Simon Josefsson.
	(GCLEF): New macro.
	(test_mit_des_s2k): Add GCLEF test case.  Fill in "key" at run
	time, not as initialization.
	(test_s2k): Added GCLEF test case.
	(krb5int_enc_aes128, krb5int_enc_aes256): Declare.
	(combine_keys, test_des3_combine, k5_des3_make_key): Functions
	deleted.
	(whoami): New variable.
	(printd, printk): New functions.
	(test_pbkdf2): New function.
	(main): Initialize whoami.  Test nfold only for now.

2003-01-10  Ken Raeburn  <raeburn@mit.edu>

	* configure.in: Don't explicitly invoke AC_PROG_ARCHIVE,
	AC_PROG_ARCHIVE_ADD, AC_PROG_RANLIB, AC_PROG_INSTALL.

	* configure.in: Use V5_AC_OUTPUT_MAKEFILE instead of
	K5_GEN_MAKEFILE and K5_AC_OUTPUT.

	* Makefile.in: Add AC_SUBST_FILE marker for lib_frag and libobj_frag.

2002-12-23  Ezra Peisach  <epeisach@bu.edu>

	* pbkdf2.c, t_encrypt.c, t_hmac.c, t_nfold.c: Cleanup unused
	variables. Signed vs unsigned cleanup. Ensure variables set before
	use.

2002-12-19  Ken Raeburn  <raeburn@mit.edu>

	* old_api_glue.c (krb5_encrypt, krb5_decrypt,
	krb5_calculate_checksum, krb5_verify_checksum): Clean up use of
	"const" in API.

2002-12-06  Ezra Peisach  <epeisach@bu.edu>

	* Makefile.in (clean): Clean up more test executables and object
	files.

2002-11-03  Ken Hornstein  <kenh@cmf.nrl.navy.mil>

	* combine_keys.c: Fix up calling convention to match prototype
	in k5-int.h

2002-10-31  Ken Raeburn  <raeburn@mit.edu>

	* Makefile.in (check-unix): Don't run t_pkcs5.

2002-10-24  Ken Hornstein  <kenh@cmf.nrl.navy.mil>

	* Makefile.in, combine_keys.c: New file to implement
	key-combination algorithm.

2002-10-09  Ken Raeburn  <raeburn@mit.edu>

	* pbkdf2.c, t_hmac.c, t_pkcs5.c: New files.
	* Makefile.in (EXTRADEPSRCS): New variable.
	(t_hmac$(EXEEXT), t_pkcs5$(EXEEXT), vectors$(EXEEXT)): New
	targets.
	(check-unix): Depend on and run t_hmac and t_pkcs5.

2002-08-29  Ken Raeburn  <raeburn@mit.edu>

	* Makefile.in: Revert $(S)=>/ change, for Windows support.

2002-08-23  Ken Raeburn  <raeburn@mit.edu>

	* Makefile.in: Change $(S)=>/ and $(U)=>.. globally.

2002-08-22  Ken Raeburn  <raeburn@mit.edu>

	* Makefile.in (SUBDIROBJLISTS): New variable.

2002-06-19  Ezra Peisach  <epeisach@bu.edu>

	* Makefile.in (clean): Add t_prng and t_prng.o

2002-06-07  Alexandra Ellwood <lxs@mit.edu>
	
	* crypto_libinit.h: Changed macros so you can include
	crypto_libinit.h and krb5_libinit.h at the same time.
	[pullup from 1-2-2-branch]

2002-04-05  Ken Raeburn  <raeburn@mit.edu>

	* coll_proof_cksum.c (krb5_c_is_coll_proof_cksum): Rename function
	from is_coll_proof_cksum, keeping old name as a wrapper function.
	* keyed_cksum.c (krb5_c_is_keyed_cksum): Likewise.
	* valid_cksumtype.c (krb5_c_valid_cksumtype): Likewise.
	* valid_enctype.c (krb5_c_valid_enctype): Likewise.

2002-03-28  Sam Hartman  <hartmans@mit.edu>

	* t_encrypt.c (main): Test krb5_init_keyblock

2002-01-14  Sam Hartman  <hartmans@mit.edu>

	* t_prng.expected: Update to be correct for 0 MSW in v_i calculation.

2002-01-08  Sam Hartman  <hartmans@tir-na-nogth.mit.edu>

	* prng.c (krb5_c_random_os_entropy):  Implement.

2001-12-05  Ezra Peisach  <epeisach@mit.edu>

	* t_encrypt.c (main): Free memory when finished to test for memory
	leaks.

2001-11-20  Ezra Peisach  <epeisach@mit.edu>

	* Makefile.in (check-unix): Use $(srcdir) in file specification
	for input to t_prng.

2001-11-19  Sam Hartman  <hartmans@mit.edu>

	* Makefile.in (check-unix): Run t_prng

2001-11-19  Danilo Almeida  <dalmeida@mit.edu>

	* Makefile.in: Do yarrow subdir on Windows.
	
2001-11-19  Sam Hartman  <hartmans@mit.edu>

	* t_prng.c (main): Fix seeding bug in t_prng

	* t_prng.reseedtest: New test; description in t_prng.reseedtest-comments

	* t_prng.c (main): If we request 0 bytes of output don't try to
	get output 

2001-11-15  Sam Hartman  <hartmans@mit.edu>

	* t_prng.c: New file for PRNG tests

	* prng.c (krb5_c_random_seed): Deprecated in favor of
	krb5_c_random_add_entropy 

2001-11-14  Sam Hartman  <hartmans@mit.edu>

	* prng.c :  adapt to yarrow

2001-11-09  Sam Hartman  <hartmans@mit.edu>

	* configure.in Makefile.in: Generate makefile for yarrow

2001-11-07  Ken Raeburn  <raeburn@mit.edu>

	* state.c (krb5_c_init_state, krb5_c_free_state): Use
	KRB5_CALLCONV.

2001-11-06  Sam Hartman  <hartmans@tir-na-nogth.mit.edu>

	* state.c: New file

	* default_state.c: New file.

2001-10-29  Jeff Altman   <jaltman@columbia.edu>

        * Makefile.in - Windows configuration for src/lib/crypto/arcfour
          directory

2001-10-24  Ezra Peisach  <epeisach@mit.edu>

	* t_encrypt.c: Argument to krb5_c_encrypt_length must be size_t
 	instead of int (which is the length in krb5_data) or unaligned
 	access occurs on Dec OSF machines.

2001-10-23  Sam Hartman  <hartmans@mit.edu>

	* Makefile.in (RUN_SETUP): Include so make check works correctly

	* etypes.c: Add Heimdal aliases  arcfour-hmac-md5

	* cksumtypes.c: hmac-md5-rc4 keyed checksum added

	* etypes.c: arcfour-hmac enctype added

	* configure.in Makefile.in :  New subdir: arcfour

	* verify_checksum.c (krb5_c_verify_checksum): Add usage argument to verify call

2001-10-22  Sam Hartman  <hartmans@mit.edu>

	* make_checksum.c (krb5_c_make_checksum):  Include key usage

2001-10-19  Sam Hartman  <hartmans@mit.edu>

	* Makefile.in (check-unix):  Run t_encrypt

	* t_encrypt.c:  New file to contain generic encryption system
	black-box tests ; currently primitive,  but useful for rc4 work

2001-10-03  Ken Raeburn  <raeburn@mit.edu>

	* block_size.c, checksum_length.c, cksumtype_to_string.c,
	coll_proof_cksum.c, decrypt.c, encrypt.c, encrypt_length.c,
	enctype_compare.c, enctype_to_string.c, keyed_checksum_types.c,
	keyed_cksum.c, make_checksum.c, make_random_key.c, old_api_glue.c,
	prng.c, string_to_cksumtype.c, string_to_enctype.c,
	string_to_key.c, valid_cksumtype.c, valid_enctype.c,
	verify_checksum.c: Don't use KRB5_DLLIMP.  Don't explicitly
	declare pointers FAR any more.

2001-09-01  Ken Raeburn  <raeburn@mit.edu>

	* Makefile.in (SRCS): Use $(srcdir) not $(subdir).

2001-07-08  Ezra Peisach  <epeisach@mit.edu>

	* crypto_libinit.c: Include crypto_libinit.h for prototypes.

2001-07-05  Ken Raeburn  <raeburn@mit.edu>

	* vectors.c: Include string.h.
	(printhex, printstringhex, printdata, printkey, test_nfold,
	test_mit_des_s2k, test_s2k, test_des3_s2k, test_des3_combine): Now
	static.
	(test_nfold): Pass unsigned first arg to printhex.
	(test_mit_des_s2k, test_s2k, combine_keys, test_des3_combine,
	spew_keys, test_dr_dk): Change structure field initializations to
	assignments, to be palatable to more compilers.
	(test_s2k): Remove superfluous argument to printf.
	(test_des3_combine): Return type is void.
	(keyToData): Drop "inline" spec.
	(main): Only run some of the tests.

2001-06-21  Ken Raeburn  <raeburn@mit.edu>

	* vectors.c: New file.

2001-06-21  Ezra Peisach  <epeisach@mit.edu>

	* t_nfold.c (main): Cast argument to printf to be consistant with
	format. 

2001-04-10  Ken Raeburn  <raeburn@mit.edu>

	* make_checksum.c (krb5_c_make_checksum): Add cast assigning to
	krb5_data data field.
	* make_random_key.c (krb5_c_make_random_key): Likewise.
	* hmac.c (krb5_hmac): Likewise.
	* old-api_glue.c (krb5_init_random_key, krb5_decrypt_data):
	Likewise.
	* prng.c (krb5_c_make_random_octets): Likewise.
	* verify_checksum.c (krb5_c_verify_checksum): Likewise.

	* prng.c (krb5_c_random_seed): Cast argument to krb5_nfold.

	* keyed_cksum.c (is_keyed_cksum): Use -1U to keep compiler quiet,
	since return type is not signed.

2001-03-14  Ken Raeburn  <raeburn@mit.edu>

	* t_nfold.c: Include assert.h.
	(printhex, printstringhex, rfc_tests): New routines.
	(ASIZE): New macro.
	(main): Call rfc_tests.

2001-03-10  Ezra Peisach  <epeisach@kangaroo.mit.edu>

	* make_random_key.c, old_api_glue.c: Do not use a variable named
	random that might shadow a system header file definition.

2001-03-09  Ken Raeburn  <raeburn@mit.edu>

	* cksumtypes.c, etypes.c, prng.c: Use krb5int_ prefix for internal
	"provider" structures.

2001-03-05  Ken Raeburn  <raeburn@mit.edu>

	* prng.c: Clean up some comments.
	(enc): Use des3 now.

	* decrypt.c, encrypt.c, hmac.c, make_checksum.c, nfold.c,
	old_api_glue.c, string_to_key.c, verify_checksum.c: Use const
	instead of krb5_const.

2001-01-29  Ken Raeburn  <raeburn@mit.edu>

	* make_checksum.c (krb5_c_make_checksum): Clear checksum contents
	pointer after freeing it in error case.

2000-10-17  Ezra Peisach  <epeisach@mit.edu>

	* nfold.c (krb5_nfold): inbots and outbits are now unsigned int. 

	* prng.c: Local variable random_count is now unsigned int. 

2000-06-30  Ezra Peisach  <epeisach@mit.edu>

	* crypto_libinit.c: Add prototype for prng_cleanup().

2000-06-28  Ezra Peisach  <epeisach@mit.edu>

	* prng.c (prng_cleanup): Ensure memory allocated before calling free.

2000-06-03  Tom Yu  <tlyu@mit.edu>

	* Makefile.in(LIBMAJOR, LIBMINOR): Bump library version.

2000-05-31  Wilfredo Sanchez  <tritan@mit.edu>

	* configure.in, nfold.c: Check for existance of <memory.h>.
	[from Nathan Neulinger <nneul@umr.edu>]

2000-01-24  Tom Yu  <tlyu@mit.edu>

	* crypto_libinit.c: Add terminating newline; use 0 and 1 instead
	of false and true.

Fri Jan 21 22:47:00 2000  Miro Jurisic  <meeroh@mit.edu>

	* Makefile.in: added crypto_libinit.[co]
	* crypto_libinit.[ch]: new files, contain library initialization
		and cleanup code

2000-01-21  Ken Raeburn  <raeburn@mit.edu>

	* cksumtypes.c (krb5_cksumtypes_list, krb5_cksumtypes_length): Now
	const.
	* cksumtypes.h (krb5_cksumtypes_list, krb5_cksumtypes_length):
	Updated decls.
	* etypes.c (krb5_enctypes_list, krb5_enctypes_length): Now const.
	* etypes.h (krb5_enctypes_list, krb5_enctypes_length): Updated
	decls.
	* make_random_key.c (krb5_c_make_random_key): Pointers to
	enc_provider table now point to const.
	* prng.c (enc): Now static and const, and points to const.
	* string_to_key.c (krb5_c_string_to_key): Ditto.

	* hmac.c (krb5_hmac): Put extra parens around if(a=b) constructs
	to keep gcc happy.
	* make_random_key.c (krb5_c_make_random_key): Ditto.
	* old_api_glue.c (krb5_encrypt, krb5_decrypt, krb5_random_key,
	krb5_calculate_checksum, krb5_verify_checksum, krb5_encrypt_data,
	krb5_decrypt_data): Ditto.
	* prng.c (krb5_c_random_make_octets): Ditto.
	* string_to_key.c (krb5_c_string_to_key): Ditto.
	* verify_checksum.c (krb5_c_verify_checksum): Ditto.

	* make_checksum.c: Include dk.h.

	* nfold.c (krb5_nfold): Delete unused variables.

1999-10-26  Wilfredo Sanchez  <tritan@mit.edu>

	* Makefile.in: Clean up usage of CFLAGS, CPPFLAGS, DEFS, DEFINES,
	LOCAL_INCLUDES such that one can override CFLAGS from the command
	line without losing CPP search patchs and defines. Some associated
	Makefile cleanup.

1999-08-26  Tom Yu  <tlyu@mit.edu>

	* etypes.c: Add aliases "des" for "des-cbc-md5", "des3-hmac-sha1"
	and "des3-cbc-sha1-kd" for "des3-cbc-sha1".

	* cksumtypes.c: Add alias "hmac-sha1-des3-kd".

1999-08-18  Tom Yu  <tlyu@mit.edu>

	* etypes.c: Update des3-cbc-sha1 to alignt with new number
	assignments.

	* cksumtypes.c: Update hmac-sha1-des3 to align with new number
	assignments.

Tue May 18 19:52:56 1999  Danilo Almeida  <dalmeida@mit.edu>

	* Makefile.in: Remove - from recursive Win32 make invocation.

Mon May 10 15:15:00 1999  Danilo Almeida  <dalmeida@mit.edu>

	* Makefile.in: Do win32 build in subdir.

Tue Jan  5 00:06:02 1999  Tom Yu  <tlyu@mit.edu>

	* make_checksum.c (krb5_c_make_checksum): Note the fact that we're
	punting on dealing with backwards compat with length-included
	checksums.

	* etypes.c: Add ENCTYPE_LOCAL_DES3_HMAC_SHA1 as a temporary
	kludge.  Note that this is added to the end of the array so other
	code can lop off the last member of the array and the right thing
	will happen so that it is possible to disable des3-marc-hmac-sha1
	from the KDC command line, for instance.

	* configure.in: Conditionalize ATHENA_DES3_KLUDGE on
	--enable-athena.

1998-11-13  Theodore Ts'o  <tytso@rsts-11.mit.edu>

	* Makefile.in: Set the myfulldir and mydir variables (which are
		relative to buildtop and thisconfigdir, respectively.)

Thu Dec  3 23:37:28 1998  Theodore Y. Ts'o  <tytso@mit.edu>

	* Makefile.in: Added missing "cd .." necessary for making this
 		compile under Windows.  Also added missing *.lst files to
 		OBJFILELIST.

Fri Nov  6 10:23:32 1998  Ezra Peisach  <epeisach@mit.edu>

	* keyhash_provider/Makefile.in: Fix to allow building out of the
 	source tree.

Tue Sep 22 21:19:01 1998  Tom Yu  <tlyu@mit.edu>

	* prng.c (krb5_c_random_make_octets): Fix to nfold into 15 bytes,
	not one byte.

Mon Sep 21 15:23:19 1998  Tom Yu  <tlyu@mit.edu>

	* prng.c (krb5_c_random_seed): Fix memory leak.

Mon Sep 14 23:21:17 1998  Tom Yu  <tlyu@mit.edu>

	* old/decrypt.c (krb5_old_decrypt): Fix memory leak.

Tue Sep  1 19:33:38 1998  Tom Yu  <tlyu@mit.edu>

	* etypes.c: Add ETYPE_LOCAL_DES3_HMAC_SHA1 to deal with marc's
	des3 code.  ETYPE_DES3_HMAC_SHA1 remains the same for now.

Mon Aug 17 23:40:11 1998  Tom Yu  <tlyu@mit.edu>

	* keyhash_provider/k5_md4des.c (k5_md4des_verify): Add
	compatibility for krb5-beta5 checksums.

	* keyhash_provider/k5_md5des.c (k5_md5des_verify): Add
	compatibility for krb5-beta5 checksums.  Fix typos similar to
	those corrected in k5_md4des.c.

Sun Jul 19 12:00:00 1998  Marc Horowitz <marc@mit.edu>

	* *.c: replace the crypto layer.

Wed Apr 15 18:02:44 1998  Tom Yu  <tlyu@mit.edu>

	* Makefile.in (LIB): Rename to k5crypto.

Wed Feb 18 16:05:11 1998  Tom Yu  <tlyu@mit.edu>

	* Makefile.in: Remove trailing slash from thisconfigdir.  Fix up
	BUILDTOP for new conventions.

Fri Feb 13 15:19:37 1998  Theodore Ts'o  <tytso@rsts-11.mit.edu>

	* Makefile.in: Define LOCAL_SUBDIRS to recurse into the
		subdirectories (crc32, md5, os, etc.)

	* configure.in: Create the makefiles for all of the subdirectories
		and move all of the configure.in tests from the
		subdirectories into this configure.in.
	
Mon Feb  2 17:02:29 1998  Theodore Ts'o  <tytso@rsts-11.mit.edu>

	* configure.in: Use AC_CONFIG_DIRS instead of CONFIG_DIRS, and
		remove use of DO_SUBDIRS.

	* Makefile.in: Define BUILDTOP and thisconfigdir in the Makefile

Tue Oct 14 15:34:44 1997  Tom Yu  <tlyu@voltage-multiplier.mit.edu>

	* Makefile.in: Bump major version due to possible size changes.

Fri Feb 21 18:40:13 1997  Sam Hartman  <hartmans@tertius.mit.edu>

	* Makefile.in (OBJS): Move in crypto_glue.c as krb5_glue.c; avoid
        libcrypto depending on libkrb5
     

Sat Feb 22 01:37:23 1997  Sam Hartman  <hartmans@luminous.MIT.EDU>

	* Makefile.in (LIBMINOR): Bump minor version

Sun Dec 29 21:52:44 1996  Tom Yu  <tlyu@mit.edu>

	* Makefile.in:
	* configure.in: Update to use new library build procedure.

Sat Nov 23 00:22:20 1996  Theodore Ts'o  <tytso@rsts-11.mit.edu>

	* cryptoconf.c: Also zero out the entries in cryptoconf, to make
		sure no one tries to use triple DES and SHA.

Fri Nov 22 20:49:13 1996  Theodore Ts'o  <tytso@rsts-11.mit.edu>

	* configure.in (enableval): Disable triple DES and SHA, since
		what's there isn't the final triple DES.  [PR#231]

Mon Nov 18 20:38:24 1996  Ezra Peisach  <epeisach@mit.edu>
 [krb5-libs/201]
	* configure.in: Set shared library version to 1.0.

Thu Jun  6 00:04:38 1996  Theodore Y. Ts'o  <tytso@mit.edu>

	* Makefile.in (all-windows): Don't pass $(LIBCMD) on the command
		line.  It's set in the windows.in prologue for all Makefiles anyway.

Thu Jun  6 00:03:05 1996  Theodore Y. Ts'o  <tytso@mit.edu>

	* Makefile.in (MAC_SUBDIRS): Include sha in the list of
		subdirectories for the Macintosh

Mon May 20 10:59:23 1996  Tom Yu  <tlyu@dragons-lair.MIT.EDU>

	* Makefile.in (libcrypto.$(STEXT): deal with new improved
		libupdate

Sat May 18 13:34:01 1996  Ezra Peisach  (epeisach@paris)

	* des3_sha.c: Add static keywords in function declarartions to
		match earlier declarations. 

Tue May 14 15:14:20 1996  Richard Basch  <basch@lehman.com>

	* cryptoconf.c:
		replaced sha-des3 cksum with hmac-sha

	* des_crc.c des_md5.c:
		set the length field of the cksum structure.

	* des3_sha.c:
		Increase the confounder length to 24 bytes.
		Set the length of the cksum structure.

Fri May 10 01:34:46 1996  Richard Basch  <basch@lehman.com>

	* configure.in cryptoconf.c des3_sha.c:
	Support enctype-des3-sha, cksum-sha, cksum-sha-des3

	* Removed des3_md5.c (and all des3-md5 support).

Tue Apr 30 00:38:14 1996  Ken Raeburn  <raeburn@cygnus.com>

	* Makefile.in (libcrypto.$(STEXT)): Remove before creating.

Thu May  2 18:48:35 1996  Richard Basch  <basch@lehman.com>

	* des3_md5.c des3_raw.c: use the new common random routines for
		des & des3 (the old des3 routines have been removed)

Sat Mar 30 22:52:46 1996  Theodore Y. Ts'o  <tytso@dcl>

	* cryptoconf.c: Fixed comments describing the various checksum
	        types.  (Added numbers, and fixed a mistake in a
		description of an undefined checksum type.)

Thu Mar 28 09:49:08 1996  Richard Basch  <basch@lehman.com>

	* cryptoconf.c: Added support for CKSUMTYPE_RSA_MD5_DES3 and
		ENCTYPE_DES3_CBC_RAW

	* des3_md5.c: Abstraction correction: use sizeof(mit_des3_cblock)

	* configure.in:
		Cosmetic renaming of des-cbc-raw configuration vars.
		Added support for des3-cbc-raw.

	* des3_raw.c: New file (support ENCTYPE_DES3_CBC_RAW)

Mon Mar 11 10:59:40 1996  Ezra Peisach  <epeisach@kangaroo.mit.edu>

	* des_crc.c (mit_des_crc_decrypt_func): Add const to pointer
		cast for suncc warning.

Wed Feb  7 00:23:18 1996  Theodore Y. Ts'o  <tytso@dcl>

	* Makefile.in: Folded in danw's changes to allow
		building Makefiles for the Macintosh.  We now can build
		MPW makefiles which are interpreted by CodeWarrior.

Mon Nov 13 11:30:10 1995  Theodore Y. Ts'o  <tytso@dcl>

	* encrypt_data.c (krb5_encrypt_data): New file.  A generic routine
		for encrypting data in a krb5_data structure.  Fills in a
		krb5_enc_data structure.

	* decrypt_data.c (krb5_decrypt_data): New file.  A generic routine
		for decrypting data in a krb5_enc_data structure.  Fills
		in a krb5_data structure.

	* Makefile.in (SRCS): Added decrypt_data.c and encrypt_data.c to
		list of files to be compiled.

Fri Oct  6 22:01:04 1995  Theodore Y. Ts'o  <tytso@dcl>

	* Makefile.in: Remove ##DOS!include of config/windows.in.
		config/windows.in is now included by wconfig.

Thu Oct  5 21:32:33 1995  Theodore Y. Ts'o  <tytso@dcl>

	* cryptoconf.c: Change types of krb5_max_enctype and
		krb5_max_cksumtype to be krb5_enctype and krb5_cksumtype,
		to fix some gcc -Wall flames.

Mon Oct  2 10:34:12 1995  Ezra Peisach  <epeisach@kangaroo.mit.edu>

	* configure.in (V5_MAKE_SHARED_LIB): Change for version 0.1 of
		shared library. Remove install lines which are in aclocal.m4

Mon Sep 25 16:26:53 1995  Theodore Y. Ts'o  <tytso@dcl>

	* Makefile.in: Removed "foo:: foo-$(WHAT)" lines from the
		Makefile. 

	* configure.in: Don't include "all:: all-$(WHAT)" at the end of
		the Makefile.  That's now included at the very beginning
		by pre.in

Wed Sep 13 10:26:37 1995 Keith Vetter (keithv@fusion.com)

	* Makefile.in: moved shared rule to all-unix:: target.
	* des_crc.c, des_md5.c, raw_des.c: had a volatile/const mismatch
	   which needs a cast to resolve.

Wed Sep 06 14:20:57 1995   Chris Provenzano (proven@mit.edu)

        * cryptoconf.c, des_crc.c, des_md5.c raw_des.c
		s/keytype/enctype/g, s/KEYTYPE/ENCTYPE/g

Tue Sep 05 22:10:34 1995   Chris Provenzano (proven@mit.edu)

        * cryptoconf.c : Remove krb5_csarray.
	* cryptoconf.c, des_crc.c, des_md5.c, raw_des.c : Remove krb5_enctype 
		references, and replace with krb5_keytype where appropriate.

Thu Aug 24 17:55:47 1995  Ezra Peisach  <epeisach@kangaroo.mit.edu>

	* des_crc.c, des_md5.c, raw_des.c: Remove casting in call to
		mit_des_cbc_encrypt. 

Thu Jul 27 15:15:46 EDT 1995	Paul Park	(pjpark@mit.edu)
	* configure.in - Add --enable-{des-cbc-md5,des-cbc-crc,raw-des-cbc,
		des-cbc-cksum,crc32,rsa-md4,rsa-md5} which set the appropriate
		preprocessor flags which used to be set in k5-config.h.
	* cryptoconf.c - Set the KEYTYPE_DES entry to the DES-CBC-MD5 entry
		if enabled, then the DES-CBC-CRC entry, if enabled, then to
		null.

Fri Jun 23 12:16:52 1995  Sam Hartman  <hartmans@tardis.MIT.EDU>

	* configure.in: krb5_cv_staticlibs_enabled, not
        krb5_cv_enable_staticlibs

Thu Jun 22 18:34:26 1995  Sam Hartman  (hartmans@tardis)

	* configure.in: Changed to new scheme for static libs.



Fri Jun 16 11:14:50 EDT 1995	Paul Park	(pjpark@mit.edu)
	* configure.in - Add install target for shared library.


Thu Jun 15 17:58:41 EDT 1995	Paul Park	(pjpark@mit.edu)
	* Makefile.in - Add definitions for shared library building rules.
		Add explicit dependency on "shared" since we probably need it.
	* configure.in - Create symlinks for archive and shared library when
		we build them.

Fri Jun  9 18:52:19 1995    <tytso@rsx-11.mit.edu>

	* des_crc.c, des_md5.c: Fix -Wall nits.

	* configure.in: Remove standardized set of autoconf macros, which
		are now handled by CONFIG_RULES.  Use DO_SUBDIRS to
		recurse down subdirectories.

Thu May 25 22:15:18 1995  Theodore Y. Ts'o  (tytso@dcl)

	* configure.in, Makefile.in: Add support for shared libraries.

Thu Apr 13 15:49:16 1995 Keith Vetter (keithv@fusion.com)

	* *.[ch]: removed unneeded INTERFACE from non-api functions.
        * *.h added FAR to pointers visible at to the world.

Tue Mar 28 20:00:00 1995 Keith Vetter (keithv@fusion.com)

	* Makefile.in: more of nmake's strange behavior. Problem goes
	   away with the addition of a nop line.

Wed Mar 22 11:28:08 1995 Keith Vetter (keithv@fusion.com)

	* Makefile.in: put back '##DOSLIBNAME' since it makes the .c.obj rule
	   put the object file into that library.
	* Makefile.in: strange nmake error 'missing ) on macro invocation' 
	   which only appeared intermitantly and only when invoked 
           recursively. Fixed (I hope) by interchanging some lines.

Thu Mar 16 21:10:37 1995  John Gilmore  (gnu at toad.com)

	* Makefile.in (CFLAGS):  Avoid continuation line that starts with
	dash; it confuses the Unix->MPW makefile converter.
	(##DOSLIBNAME):  No longer needed since DLL built one level up.
	(all-mac):  Add.
	(libcrypto.a):  Use explicit "./" on paths to DONE files, to
	help Unix->MPW makefile converter with rotten Mac pathname conventions.

Wed Mar 15 20:23:17 1995 Keith Vetter (keithv@fusion.com)

	* Makefile.in: cleaned up for the PC

Tue Mar 14 17:31:01 1995 Keith Vetter (keithv@fusion.com)

	* Makefile.in: removed all DLL stuff--it now happens up a directory.
	* win_glue.c, libcrypto.def: removed

Tue Mar 7 17:26:06 1995 Keith Vetter (keithv@fusion.com)

	* cryptoco.c: Added more windows syntactic sugar for segmenting.

Fri Mar 3 19:15:54 1995 Keith Vetter (keithv@fusion.com)

	* libcrypto.def: added 3 entry points for methods for pulling
           in data from a DLL.
        * Makefile.in: libcrypto.lib depends upon libcrypto.def

Thu Mar 2 17:43:25 1995 Keith Vetter (keithv@fusion.com)

	* Makefile.in: added rules to make a DLL from a lib.
        * win_glue.c, librcrypto.def: needed for making a DLL.

Tue Feb 28 00:15:06 1995  John Gilmore  (gnu at toad.com)

	* cryptoconf.c, des_md5.c:  Avoid <krb5/...> includes.

Fri Feb  3 02:44:07 1995  John Gilmore  <gnu@cygnus.com>

	Rename files so that they work in the DOS LIB command,
	which amazingly finds dashes in mid-name and treats them
	like option switches.

	* des-crc.c => des_crc.c
	* des-md5.c => des_md5.c
	* raw-des.c => raw_des.c
	* Makefile.in:  changed to match.

Thu Feb  2 02:59:58 1995  John Gilmore  <gnu@cygnus.com>

	* Makefile.in (CFLAGS):  Handle $(srcdir) properly in -I options.

Wed Jan 25 19:55:59 1995  John Gilmore  (gnu at toad.com)

	* Makefile.in (CFLAGS):  Add -I options to pick up include files
	from the various algorithm subdirs.
	* cryptoconf.c, des-crc.c, des-md5.c, raw-des.c:  Replace most
	<.../...> include files with "..." includes.

Tue Oct 18 15:46:01 1994  Mark Eichin  (eichin@cygnus.com)

	* des-crc.c (mit_des_crc_decrypt_func): cast key->key->contents to
	krb5_pointer to satisfy sunos cc about :? argument types.
	(mit_des_crc_encrypt_funct): ditto.
	* raw-des.c (mit_raw_des_decrypt_func): ditto.
	(mit_raw_des_encrypt_func): ditto.
	* des-md5.c (mit_des_md5_decrypt_funct): cast zero_ivec.
	(mit_des_md5_encrypt_funct): ditto.

Fri Oct 14 00:37:08 1994  Theodore Y. Ts'o  (tytso@dcl)

    	* cryptoconf.c: Add support for the new cryptosystem DES/MD5.

	* Makefile.in: Add support for new files des-crc.c, des-md5.c, and
		raw-des.c

Thu Oct  6 20:07:41 1994  Theodore Y. Ts'o  (tytso@dcl)

	* configure.in: Add recursive "make check" target.

Mon Oct  3 21:11:56 1994  Theodore Y. Ts'o  (tytso@dcl)

	* Makefile.in: make install obey $(DESTDIR)

Thu Aug  4 03:40:24 1994  Tom Yu  (tlyu@dragons-lair)

	* configure.in: oops check for install

	* Makefile.in: make install fixes

